package com.gic.haoban.manage.web.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.dto.ClerkListDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.enterprise.api.dto.EnterpriseDTO;
import com.gic.enterprise.api.dto.GicTreeDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreGroupService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.Constant;
import com.gic.haoban.base.api.common.PageResult;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.web.auth.AuthRequestUtil;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.qo.DepartmentAddQO;
import com.gic.haoban.manage.web.qo.DepartmentEditQO;
import com.gic.haoban.manage.web.qo.SyncDealQO;
import com.gic.haoban.manage.web.qo.SyncDepartmentQO;
import com.gic.haoban.manage.web.thread.SyncDepartmentThread;
import com.gic.haoban.manage.web.vo.DepartmentVO;
import com.gic.haoban.manage.web.vo.LoginVO;
import com.gic.redis.data.util.RedisUtil;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;

@RestController
public class SyncDealContoller extends WebBaseController {

    private static Logger logger = LoggerFactory.getLogger(SyncDealContoller.class);
    @Autowired
    private DepartmentApiService departmentApiService;

    @Autowired
    private StoreGroupService storeGroupService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private StaffApiService staffApiService;

    @Autowired
    private EnterpriseService enterpriseService;
    @Autowired
    private ClerkService clerkService;

    @Autowired
    private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;


    @RequestMapping("department-sync")
    @ResponseBody
    public HaobanResponse departmentBatchSync(@RequestBody SyncDealQO qo) {
        LoginVO login = (LoginVO) AuthRequestUtil.getSessionUser();
        String wxEnterpriseId = login.getWxEnterpriseId();
        String key = "haoban-sync-department-" + wxEnterpriseId;
        if (RedisUtil.getCache(key) != null) {
            return resultResponse(HaoBanErrCode.ERR_10011);
        }
        Object editDepartmentObject = null;
        Object addDepartmentObject = null;
        String editDepartment = "";
        String addDepartment = "";
        String delDepartmentIds = "";
        logger.info("【部门同步】args={}", JSON.toJSONString(args));
        if (args != null) {
            editDepartmentObject = args.getEditDepartment();
            addDepartmentObject = args.getAddDepartment();
            editDepartment = JSON.toJSONString(editDepartmentObject);
            addDepartment = JSON.toJSONString(addDepartmentObject);
        }
        RedisUtil.setCache(key, 1, 3600l);
        new SyncDepartmentThread(this, editDepartment, delDepartmentIds, addDepartment, key).start();

        return resultResponse(HaoBanErrCode.ERR_1, key);

    }

    @RequestMapping("department-batch-sync-success")
    public HaobanResponse syncSuccess(String syncKey) {
        if (RedisUtil.getCache(syncKey) == null) {
            return resultResponse(HaoBanErrCode.ERR_1, true);
        } else {
            return resultResponse(HaoBanErrCode.ERR_1, false);
        }
    }


}
